package org.netkernel.layer0.boot;

import java.io.File;
import java.io.FileOutputStream;
import java.net.URI;

import org.netkernel.container.IKernel;
import org.netkernel.layer0.representation.IBinaryStreamRepresentation;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.urii.ClassLoaderResourceRepresentation;
import org.netkernel.layer0.util.Utils;

public class BootPersistence
{
	public static IReadableBinaryStreamRepresentation sourceBootResource(String aName, IKernel aKernel) throws Exception
	{
		String path="etc/"+aName;
		ClassLoaderResourceRepresentation result = new ClassLoaderResourceRepresentation(path, BootPersistence.class.getClassLoader());
		if (result.getURL()==null)
		{	throw Utils.createFormattedException("EX_LR0_RES_NOTFOUND","MSG_LR0_RES",aKernel.getLogger(),"/"+path);
		}
		return result;
	}
	
	public static void sinkBootResource(String aName, IBinaryStreamRepresentation aRepresentation, IKernel aKernel) throws Exception
	{
		String installPath=aKernel.getConfiguration().getString("netkernel.install.path");
		String resourceURI=installPath+"/etc/"+aName;
		File f = new File(URI.create(resourceURI));
		FileOutputStream fos = new FileOutputStream(f);
		try
		{	aRepresentation.write(fos);
		}
		finally
		{	fos.close();			
		}
	}
	
	public static void deleteBootResource(String aName, IKernel aKernel) throws Exception
	{
		String installPath=aKernel.getConfiguration().getString("netkernel.install.path");
		String resourceURI=installPath+"/etc/"+aName;
		File f = new File(URI.create(resourceURI));
		f.delete();
	}
}
