package org.netkernel.layer0.meta;

import org.netkernel.urii.IMetaRepresentation;

public interface IEndpointMeta extends IMetaRepresentation
{
	/** Returns an integer with all valid verb values bitwise ORed together
	 */
	int getSupportedVerbs();
		
	/** Returns an optional grammar which can be used to match, parse and serialize identifiers for resources reified by this endpoint
	 */
	IIdentifierGrammar getIdentifierGrammar();
	
	/** Additional non-syntactic information about the arguments of the endpoint
	 */
	IEndpointArgumentMeta[] getArguments();
	
	/** Returns an optional array of classes of representation returnable as a response from this endpoint
	 */
	Class[] getResponseClasses();
	
	/** Returns the set of expected exception ids thrown from this endpoint
	 */
	IMetaRepresentation[] getExceptions();	
	
}
