package org.netkernel.layer0.meta.impl;

import org.netkernel.layer0.meta.IEndpointArgumentMeta;
import org.netkernel.urii.IIdentifier;


public class EndpointArgumentMetaImpl extends LightMetaRepresentationImpl implements IEndpointArgumentMeta
{
	private final String mDefaultValue;
	private final boolean mIsIdentifier;
	private final Class[] mRequiredRepresentations;

	public EndpointArgumentMetaImpl(String aName, String aDescription, IIdentifier aIcon, IIdentifier aDoc,
			String aDefaultValue, boolean aIsIdentifier, Class[] aRequiredRepresentations)
	{	super(aName,aDescription);
		mDefaultValue=aDefaultValue;
		mIsIdentifier=aIsIdentifier;
		mRequiredRepresentations=aRequiredRepresentations;
	}
	
	public String getDefaultValue()
	{	return mDefaultValue;
	}

	public boolean isIdentifier()
	{	return mIsIdentifier;
	}
	
	public Class[] getRequiredRepresentations()
	{	return mRequiredRepresentations;
	}

	public ArgumentType getArgumentType()
	{	return mIsIdentifier?ArgumentType.REPRESENTATION:ArgumentType.STRING;
	}

	public String getSubstringType()
	{	return null;
	}
}